<template>
  <div>
    <div class="row">
      <div class="col-12">
        <div class="text-right">
          <button class="btn btn-success mr-2" @click.prevent="load">
            Load Item
          </button>
          <button class="btn btn-primary mr-2" @click.prevent="save()">
            Simpan Change Management Item
          </button>
          <a @click.prevent="addItem()">
            <i class="flaticon2-plus"></i>
          </a>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-12">
        <div class="table-responsive">
          <table class="table">
            <thead>
              <tr>
                <th style="min-width: 150px">Number</th>
                <th style="min-width: 100px">Type</th>
                <th style="min-width: 150px">Date</th>
                <th style="min-width: 150px">Title / Issues</th>
                <th style="min-width: 150px">Requestor</th>
                <th style="min-width: 150px">Attachment Detail</th>
                <th style="min-width: 150px">Soft File</th>
                <th style="min-width: 150px">Hard File</th>
                <th style="min-width: 150px">feedback</th>
                <th style="min-width: 150px">Bagian</th>
                <th style="min-width: 150px">Response</th>
                <th style="min-width: 200px">Receive Date</th>
                <th style="min-width: 150px">Upload soft file</th>
                <th style="min-width: 150px" class="text-center">Aksi</th>
              </tr>
            </thead>
            <template
              v-if="
                this.$store.getters.getterManagementItem.length == 0 ||
                  this.$store.getters.getterManagementItem == '400'
              "
            >
              <tbody>
                <tr
                  v-bind:class="{
                    'd-none': tableEmpty
                  }"
                >
                  <template v-if="isLoading">
                    <td colspan="14" class="text-center">
                      <b-spinner variant="primary" label="Spinning"></b-spinner>
                    </td>
                  </template>
                  <template v-else>
                    <td colspan="14">
                      <div class="text-center">
                        <i
                          class="flaticon2-open-box text-secondary icon-3x"
                        ></i>

                        <template v-if="isEmpty">
                          <h4>
                            Data tidak di temukan
                          </h4>
                        </template>
                        <template v-else>
                          <h4>
                            Data kosong.
                          </h4>
                        </template>
                      </div>
                    </td>
                  </template>
                </tr>
              </tbody>
            </template>
            <template v-else>
              <template
                v-for="(item, i) in this.$store.getters.getterManagementItem"
              >
                <tbody v-bind:key="i">
                  <template>
                    <tr>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <input
                              type="text"
                              class="form-control"
                              v-model="edit.cr_number"
                            />
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{ item.change_management.cr_number }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-select
                              v-model="edit.type"
                              :options="option.edit.type"
                            ></b-form-select>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{ item.type.name }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <input
                              type="date"
                              class="form-control"
                              v-model="edit.date"
                            />
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{ item.date == null ? "-" : item.date }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <input
                              type="text"
                              class="form-control"
                              v-model="edit.title"
                            />
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{ item.issue == null ? "-" : item.issue }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <input
                              type="text"
                              class="form-control"
                              v-model="edit.requestor"
                            />
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{
                              item.requestor == null ? "-" : item.requestor.name
                            }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-checkbox
                              v-bind:id="'checkbox-form-' + i"
                              v-model="edit.attachment_detail"
                              name="checkbox-1"
                              value="1"
                              unchecked-value="null"
                            ></b-form-checkbox>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            <template v-if="item.attachment_detail == 1">
                              <input
                                type="checkbox"
                                checked
                                :value="item.attachment_detail"
                                disabled
                              />
                            </template>
                            <template v-else>
                              <input
                                type="checkbox"
                                disabled
                                :value="item.attachment_detail"
                              />
                            </template>
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-checkbox
                              v-bind:id="'checkbox-form-' + i"
                              v-model="edit.soft_file"
                              name="checkbox-2"
                              value="1"
                              unchecked-value="null"
                            ></b-form-checkbox>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            <template v-if="item.soft_file == 1">
                              <input
                                type="checkbox"
                                checked
                                :value="item.soft_file"
                                disabled
                              />
                            </template>
                            <template v-else>
                              <input
                                type="checkbox"
                                disabled
                                :value="item.soft_file"
                              />
                            </template>
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-checkbox
                              v-bind:id="'checkbox-form-' + i"
                              v-model="edit.hard_file"
                              name="checkbox-3"
                              value="1"
                              unchecked-value="null"
                            ></b-form-checkbox>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            <template v-if="item.hard_file == 1">
                              <input
                                type="checkbox"
                                checked
                                :value="item.hard_file"
                                disabled
                              />
                            </template>
                            <template v-else>
                              <input
                                type="checkbox"
                                disabled
                                :value="item.hard_file"
                              />
                            </template>
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-checkbox
                              v-bind:id="'checkbox-form-' + i"
                              v-model="edit.feedback"
                              name="checkbox-4"
                              value="1"
                              unchecked-value="null"
                            ></b-form-checkbox>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            <template v-if="item.feedback == 1">
                              <input
                                type="checkbox"
                                checked
                                :value="item.feedback"
                                disabled
                              />
                            </template>
                            <template v-else>
                              <input
                                type="checkbox"
                                disabled
                                :value="item.feedback"
                              />
                            </template>
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-select
                              v-model="edit.scope"
                              :options="option.edit.scope"
                            ></b-form-select>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{
                              item.scope_category == null
                                ? "-"
                                : item.scope_category.name
                            }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-select
                              v-model="edit.response"
                              :options="option.edit.response"
                            ></b-form-select>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            -
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <input
                              type="date"
                              class="form-control"
                              v-model="edit.received_date"
                            />
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            {{
                              item.receive_date == null
                                ? "-"
                                : item.receive_date
                            }}
                          </div>
                        </template>
                      </td>
                      <td>
                        <template>
                          <div v-bind:class="'d-none edit-form-change-' + i">
                            <b-form-file
                              v-model="edit.file"
                              ref="file-input"
                              class="mb-2"
                            ></b-form-file>
                          </div>
                          <div v-bind:class="'edit-text-change-' + i">
                            <a href="">
                              {{
                                item.soft_filename == null
                                  ? "-"
                                  : item.soft_filename
                              }}
                            </a>
                          </div>
                        </template>
                      </td>
                      <td class="text-center">
                        <template>
                          <div
                            class="d-none"
                            v-bind:id="'edit-cancel-change-' + i"
                          >
                            <a @click.prevent="cancelEdit(i)">
                              <i class="flaticon2-cross text-danger"></i>
                            </a>
                          </div>
                          <div v-bind:id="'edit-action-change-' + i">
                            <a
                              class="btn btn-light-success mr-2"
                              @click.prevent="editItem(item, i)"
                            >
                              <i class="flaticon-edit"></i>
                            </a>
                            <a class="btn btn-light-danger">
                              <i class="flaticon-delete"></i>
                            </a>
                          </div>
                        </template>
                      </td>
                    </tr>
                  </template>
                </tbody>
              </template>
            </template>

            <!-- add template -->
            <template>
              <tbody
                v-bind:class="{
                  'd-none': isAdd
                }"
              >
                <tr>
                  <td>
                    <input
                      type="text"
                      class="form-control"
                      v-model="edit.cr_number"
                    />
                  </td>
                  <td>
                    <b-form-select v-model="edit.type" class="mb-3">
                      <b-form-select-option :value="null"
                        >option</b-form-select-option
                      >
                    </b-form-select>
                  </td>
                  <td>
                    <input
                      type="date"
                      class="form-control"
                      v-model="edit.date"
                    />
                  </td>
                  <td>
                    <input
                      type="text"
                      class="form-control"
                      v-model="edit.title"
                    />
                  </td>
                  <td>
                    <input
                      type="text"
                      class="form-control"
                      v-model="edit.requestor"
                    />
                  </td>
                  <td>
                    <b-form-checkbox
                      id="checkbox-1"
                      v-model="edit.attachment_detail"
                      name="checkbox-1"
                      value="1"
                      unchecked-value="null"
                    ></b-form-checkbox>
                  </td>
                  <td>
                    <b-form-checkbox
                      id="checkbox-2"
                      v-model="edit.soft_file"
                      name="checkbox-2"
                      value="1"
                      unchecked-value="null"
                    ></b-form-checkbox>
                  </td>
                  <td>
                    <b-form-checkbox
                      id="checkbox-3"
                      v-model="edit.hard_file"
                      name="checkbox-3"
                      value="1"
                      unchecked-value="null"
                    ></b-form-checkbox>
                  </td>
                  <td>
                    <b-form-checkbox
                      id="checkbox-4"
                      v-model="edit.feedback"
                      name="checkbox-4"
                      value="1"
                      unchecked-value="null"
                    ></b-form-checkbox>
                  </td>
                  <td>
                    <b-form-select v-model="edit.scope" class="mb-3">
                      <b-form-select-option :value="null"
                        >option</b-form-select-option
                      >
                    </b-form-select>
                  </td>
                  <td>
                    <b-form-select v-model="edit.response" class="mb-3">
                      <b-form-select-option :value="null"
                        >option</b-form-select-option
                      >
                    </b-form-select>
                  </td>
                  <td>
                    <input
                      type="date"
                      class="form-control"
                      v-model="edit.received_date"
                    />
                  </td>
                  <td>
                    <b-form-file
                      v-model="edit.file"
                      ref="file-input"
                      class="mb-2"
                    ></b-form-file>
                  </td>
                  <td class="text-center">
                    <a @click.prevent="cancelAdd()">
                      <i class="flaticon2-cross text-danger"></i>
                    </a>
                  </td>
                </tr>
              </tbody>
            </template>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {
  GET_MANAGEMENT_ITEM,
  GET_MANAGEMENT_TYPE,
  GET_MANAGEMENT_SCOPE,
  GET_PIC_CHANGE,
  GET_FILE_DIRECTORY
} from "@/core/services/store/change-management.module";

export default {
  name: "ManagementItem",
  data() {
    return {
      edit: {
        cr_number: null,
        type: null,
        date: null,
        title: null,
        requestor: null,
        attachment_detail: null,
        soft_file: null,
        hard_file: null,
        feedback: null,
        scope: null,
        response: null,
        received_date: null,
        file: null,
        id_change_management: null
      },
      option: {
        edit: {
          type: { text: "loading..." },
          scope: { text: "loading..." },
          response: { text: "loading..." }
        }
      },
      isLoading: false,
      isEdit: false,
      isAdd: true,
      isEmpty: false,
      tableEmpty: false
    };
  },
  methods: {
    async load() {
      this.isLoading = true;
      await this.$store.dispatch(GET_MANAGEMENT_ITEM, {
        id: this.$route.params.id_change_management
      });
      if (this.$store.getters.getterManagementItem == "400") {
        this.isLoading = false;
        this.isEmpty = true;
      } else {
        this.isLoading = false;
        this.isEmpty = false;
      }
    },

    async editItem(item, id) {
      var input = document.getElementsByClassName("edit-form-change-" + id);
      var text = document.getElementsByClassName("edit-text-change-" + id);
      var cancel = document.getElementById("edit-cancel-change-" + id);
      var action = document.getElementById("edit-action-change-" + id);

      if (this.isEdit == false) {
        this.isEdit = true;

        // set id change management
        var idChange = item.change_management.id;
        this.edit.id_change_management = idChange;

        for (var i = 0; i < input.length; i++) {
          input[i].classList.remove("d-none");
          text[i].classList.add("d-none");
        }

        cancel.classList.remove("d-none");
        action.classList.add("d-none");

        // ################ get data #################
        // type
        await this.$store.dispatch(GET_MANAGEMENT_TYPE);
        var ops = [];
        var listType = this.$store.getters.getterTypeManagement;
        for (var t = 0; t < listType.length; t++) {
          ops.push({
            value: listType[t].code + "-" + listType[t].name,
            text: listType[t].code + " - " + listType[t].name
          });
        }
        this.option.edit.type = ops;

        // scope
        await this.$store.dispatch(GET_MANAGEMENT_SCOPE);
        var scopes = [];
        var listScopes = this.$store.getters.getterScopeManagement;
        for (var s = 0; s < listScopes.length; s++) {
          scopes.push({
            value: listScopes[s].code + "-" + listScopes[s].name,
            text: listScopes[s].code + " - " + listScopes[s].name
          });
        }
        this.option.edit.scope = scopes;

        // pic
        await this.$store.dispatch(GET_PIC_CHANGE);
        var pics = [];
        var listPic = this.$store.getters.getterPicChangeMangement;
        for (var p = 0; p < listPic.length; p++) {
          pics.push({
            value: listPic[p].code + "-" + listPic[p].name,
            text: listPic[p].code + " - " + listPic[p].name
          });
        }
        this.option.edit.response = pics;
      } else {
        this.$bvToast.toast("Selesaikan Edit data terlebih dahulu", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      }
    },

    async cancelEdit(id) {
      var input = document.getElementsByClassName("edit-form-change-" + id);
      var text = document.getElementsByClassName("edit-text-change-" + id);
      var cancel = document.getElementById("edit-cancel-change-" + id);
      var action = document.getElementById("edit-action-change-" + id);

      for (var i = 0; i < input.length; i++) {
        input[i].classList.add("d-none");
        text[i].classList.remove("d-none");
      }

      cancel.classList.add("d-none");
      action.classList.remove("d-none");

      this.edit.id_change_management = "";

      this.isEdit = false;
    },

    async save() {
      var detail = this.$store.getters.getterDetailChangeManagement;
      var code = detail.project.code;
      var idChange = this.edit.id_change_management;

      var getType = this.edit.type;
      var splitType = getType.split("-");
      var type = {
        code: splitType[0],
        name: splitType[1]
      };

      var change_management = {
        id: idChange,
        cr_number: this.edit.cr_number,
        title: this.edit.title
      };

      var date = this.edit.date;
      var issue = this.edit.title;
      var softFile = this.edit.soft_file;
      var hardFile = this.edit.hard_file;
      var attachment = this.edit.attachment_detail;
      var feedback = this.edit.feedback;

      var getScope = this.edit.scope;
      var splitScope = getScope.split("-");
      var scope = {
        code: splitScope[0],
        name: splitScope[1]
      };

      var getRequestor = this.edit.requestor;
      var splitRequestor = getRequestor.split("-");
      var requestor = {
        code: splitRequestor[0],
        name: splitRequestor[1]
      };

      var plan_date = this.edit.received_date;

      // get file directory
      var fileName = this.edit.file.name;

      var sendFile = {
        project_code: code,
        server_type: "DEV",
        folder_id: "97",
        filename: fileName
      };

      // get directory
      await this.$store.dispatch(GET_FILE_DIRECTORY, { send: sendFile });
      var res = this.$store.getters.getterFileDirectory;

      var path = res.folder;

      var send = [
        {
          code: code,
          type: type,
          change_management: change_management,
          date: date,
          issue: issue,
          soft_file: softFile,
          hard_file: hardFile,
          attachment_detail: attachment,
          feedback: feedback,
          scope_category: scope,
          requestor: requestor,
          plan_date: plan_date,
          soft_filename: path
        }
      ];

      console.log(send);
    },

    addItem() {
      if (
        this.$store.getters.getterManagementItem.length == 0 ||
        this.$store.getters.getterManagementItem == "400"
      ) {
        this.isAdd = false;
        this.tableEmpty = true;
      } else {
        this.isAdd = false;
        this.tableEmpty = false;
      }
    },

    cancelAdd() {
      this.isAdd = true;
      this.tableEmpty = false;
      this.resetField();
    },

    resetField() {
      (this.edit.cr_number = null),
        (this.edit.type = null),
        (this.edit.date = null),
        (this.edit.title = null),
        (this.edit.requestor = null),
        (this.edit.attachment_detail = null),
        (this.edit.soft_file = null),
        (this.edit.hard_file = null),
        (this.edit.feedback = null),
        (this.edit.scope = null),
        (this.edit.response = null),
        (this.edit.received_date = null),
        (this.edit.file = null),
        (this.edit.id_change_management = null);
    }
  }
};
</script>
